/*****************************************************************/
/*  ELEC 999                                                     */
/*  University of Nebraska-Lincoln                               */
/*  Department of Electrical Engineering                         */
/*  David J. Russell                                             */
/*  1-29-09                                                      */
/*                                                               */
/* 01/30/09 - Added % distribution to output type, version 1.1   */
/* 01/31/09 - Added windowing across an input, version 1.2       */
/* 02/03/09 - Added unpaired repeats and modified paired counts, */
/*             version 1.3                                       */
/* 02/14/09 - Added html output type where text is colored to    */
/*             identify the structural pieces. Modified          */
/*             VectorADT to allow longer vectors, version 1.5    */
/*****************************************************************/

#ifdef _DIST
#define DIST_EXTERN
#else
#define DIST_EXTERN extern
#endif

/******************************************************************/
/* Public Module Constants                                        */
/******************************************************************/

/******************************************************************/
/* Public Type Definitions                                        */
/******************************************************************/

/*********************************************************************************/
/* Public Module Variables */
/*********************************************************************************/

/*********************************************************************************/
/* Public Module Function Prototypes */
/*********************************************************************************/

void DIST_GenerateStructureDistribution(CNFADT_DICTIONARY_TYPE *Dictionary, 
                                          CNFADT_HEAD_TYPE Head,
                                          ULONG SequenceLength,
                                          FLOAT *UnpairedRepeatPercentage,
                                          FLOAT *PairedPercentage);
void DIST_CleanUpPiecesArray(void);
ULONG DIST_GetPiecesArray(ULONG **Array);

