/*****************************************************************/
/*  ELEC 999                                                     */
/*  University of Nebraska-Lincoln                               */
/*  Department of Electrical Engineering                         */
/*  David J. Russell                                             */
/*  5-26-08                                                      */
/*                                                               */
/* 01/30/09 - Added % distribution to output type, version 1.1   */
/* 01/31/09 - Added windowing across an input, version 1.2       */
/* 02/14/09 - Added html output type where text is colored to    */
/*             identify the structural pieces. Modified          */
/*             VectorADT to allow longer vectors, version 1.5    */
/*****************************************************************/

#ifdef _FILEIO
#define FILEIO_EXTERN
#else
#define FILEIO_EXTERN extern
#endif

/******************************************************************/
/* Public Module Constants                                        */
/******************************************************************/

/******************************************************************/
/* Public Type Definitions                                        */
/******************************************************************/

/*********************************************************************************/
/* Public Module Variables */
/*********************************************************************************/

/*********************************************************************************/
/* Public Module Function Prototypes */
/*********************************************************************************/
void FILEIO_ReadFASTASequences(STRINGLISTADT_STRINGLIST_TYPE *Sequences,
                                 STRINGLISTADT_STRINGLIST_TYPE *MergedAlphabetSequences,
                                 STRINGLISTADT_STRINGLIST_TYPE *HeaderLines);
void FILEIO_PrintVerboseDictionaryToFile(CNFADT_DICTIONARY_TYPE *Dictionary);
void FILEIO_PrintCompressedDictionaryToFile(CNFADT_DICTIONARY_TYPE *Dictionary);
void FILEIO_PrintDistributionStringToFile(STRINGADT_STRING_TYPE *DistributionString);
void FILEIO_WriteHTMLColoredSequence(STRINGADT_STRING_TYPE *Sequence,
                                     ULONG *SequencePieces,
                                     ULONG Length);

