/*****************************************************************/
/*  ELEC 999                                                     */
/*  University of Nebraska-Lincoln                               */
/*  Department of Electrical Engineering                         */
/*  David J. Russell                                             */
/*  5-17-08                                                      */
/*                                                               */
/* 01/30/09 - Added % distribution to output type, version 1.1   */
/* 01/31/09 - Added windowing across an input, version 1.2       */
/* 02/03/09 - Added unpaired repeats and modified paired counts, */
/*             version 1.3                                       */
/* 02/07/09 - Added extreme-value % removal for the stats output,*/
/*             version 1.4                                       */
/* 02/14/09 - Added html output type where text is colored to    */
/*             identify the structural pieces. Modified          */
/*             VectorADT to allow longer vectors, version 1.5    */
/* 02/16/09 - Added minimum ID parameter for labeling nodes on   */
/*             .eps outputs, version 1.6                         */
/* 02/17/09 - Added a parameter to control how many nodes below  */
/*             the root of a structural node are shown on the    */
/*             .eps outputs, version 1.7                         */
/*****************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <ctype.h>
#include <time.h>

/******************************************************************/
/* Public Module Constants                                        */
/******************************************************************/
#define VERSION_MAJOR            1
#define VERSION_MINOR            7
#define VERSION_DATE             "2/17/09"

#define COIN_FLIP                ((rand() & 0x01) == 0x01)
#define MIN(a,b)                 ((a)<(b)?(a):(b))
#define MAX(a,b)                 ((a)>(b)?(a):(b))
#define NOT(a)                   ((a==TRUE)?(FALSE):(TRUE))

#define ALPHABETIC_CHARACTERS    27 /* Including an unknown index */ 
#define ALPHABETIC_UNKNOWN_INDEX 26
#define ALPHA_INDEX(a)           (((a >= 'A') && (a <= 'Z'))?(a - 'A'):(ALPHABETIC_UNKNOWN_INDEX))

/******************************************************************/
/* Public Type Definitions                                        */
/******************************************************************/
typedef char            BYTE;
typedef unsigned char   UBYTE;

typedef short           SHORT;
typedef unsigned short  USHORT;

typedef long            LONG;
typedef unsigned long   ULONG;

typedef float           FLOAT;
typedef double          DOUBLE;

typedef int             INT;
typedef unsigned int    UINT;

typedef enum
{
   FALSE,
   TRUE
} BOOLEAN;

/*********************************************************************************/
/* Public Module Variables */
/*********************************************************************************/

/*********************************************************************************/
/* Public Module Function Prototypes */
/*********************************************************************************/
